﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace IIKolok
{
    public delegate bool UslovSelekcije<T>(T t);
    public delegate bool UslovSortiranja<T>(T t,T m);

    public class Lista<T> :IUporediv<Lista<T>> where T:IUporediv<T>
    {
        public T element;
        public Lista<T> sledeci;

        public Lista(T t)
        {
            element = t;
            sledeci = null;
        }

        public IEnumerable<Lista<T>> VratiEnumerator()
        {
            bool ind = true;
            Lista<T> trenutni = this;
            while(ind==true)
            {
                if(trenutni.sledeci==null)
                    ind=false;
                yield return trenutni;
                trenutni = this.sledeci;
	        }   
        }

        public bool DaLiSadrzi(T t)
        {
            if (this == null) return false;
            foreach (Lista<T> item in VratiEnumerator())
            {
                if (item.element.Uporediv(t))
                    return false;
            }
            return true;
        }

        public void Add(T t)
        {
            if(!DaLiSadrzi(t))
                foreach (Lista<T> item in VratiEnumerator())
                {
                    if (item.sledeci==null)
                        item.sledeci = new Lista<T>(t);
                }
        }

        public Lista<T> this[int index]
        {
            get
            {
                return this[index];
            }
        }

        public int Count()
        {
            int count = 0;
            foreach (Lista<T> item in VratiEnumerator())
            {
                count++;
            }
            return count;
        }

        public IEnumerable<Lista<T>> VratiEnumeratorPremaSelekciji(UslovSelekcije<T> selektor)
        {
            foreach (Lista<T> item in VratiEnumerator())
            {
                if (selektor(item.element))
                  yield return item;
            }
        }

        public Lista<T> VratiSortiranuListu(UslovSortiranja<T> sortiranje)
        {
            Lista<T> pom;
            for (int i = 1; i < Count(); i++)
            {
                for (int j = 2; j < Count(); j++)
                {
                    if (sortiranje(this[i].element, this[j].element))
                    {

                        if (i != 0)
                        {
                            pom = this[i];
                            this[i - 1].sledeci = this[j];
                            this[j - 1].sledeci = this[i];
                        }
                    }
                }
            }
            return this;
        }

        public bool Uporediv(Lista<T> t)
        {
            return this == t;
        }

        public Lista<T> VratiListuPremaSelekciji(UslovSelekcije<T> selektor)
        {
            Lista<T> lista = null;
            foreach (Lista<T> item in VratiEnumeratorPremaSelekciji(selektor))
            {
                if (lista.sledeci == null)
                    lista = new Lista<T>(item.element);
                else
                    lista.Add(item.element);
            }
            return lista;
        }
    }
}
