﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.IO;

namespace Kolokvijum
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        Lista<Sportista> svi;

        StreamReader srK = new StreamReader("C:\\Users\\student\\Desktop\\Rad\\Jovan_Jancic_58_12\\Kolokvijum\\kosarkasi.csv");
        StreamReader srF = new StreamReader("C:\\Users\\student\\Desktop\\Rad\\Jovan_Jancic_58_12\\Kolokvijum\\fudbaleri.csv");

        public MainWindow()
        {
            srK.ReadLine();

            string ime, prezime, regBr, sve, datum, pol;
            Pol polSportiste;
            DateTime dat;
            int golovi, asistencije, poeni, uhvaceneLopte, dan, mesec, godina, ind = 0;

            cb.Items.Add("Sortirana lista sportista prema indeksu korisnosti");
            cb.Items.Add("Kosarkasice i fudbalerke");

            while (srK.EndOfStream)
            {
                sve = srK.ReadLine();

                regBr = sve.Split(',')[0];
                ime = sve.Split(',')[1];
                prezime = sve.Split(',')[2];
                datum = sve.Split(',')[3];
                dan = int.Parse(datum.Split('.')[0]);
                mesec = int.Parse(datum.Split('.')[1]);
                godina = int.Parse(datum.Split('.')[2]);
                dat = new DateTime(godina, mesec, dan);
                poeni = int.Parse(sve.Split(',')[4]);
                asistencije = int.Parse(sve.Split(',')[5]);
                uhvaceneLopte = int.Parse(sve.Split(',')[6]);
                pol = sve.Split(',')[7];
                if (pol == "m")
                    polSportiste = Pol.muski;
                else
                    polSportiste = Pol.zenski;

                if (ind == 0)
                {
                    svi = new Lista<Sportista>(new Kosarkas(regBr, ime, prezime, dat, polSportiste, asistencije, poeni, uhvaceneLopte));
                    ind++;
                }
                else
                    svi.Add(new Kosarkas(regBr, ime, prezime, dat, polSportiste, asistencije, poeni, uhvaceneLopte));
            }

            srF.ReadLine();
            
            while (!srF.EndOfStream)
            {
                sve = sve = srF.ReadLine();
                regBr = sve.Split(',')[0];
                ime = sve.Split(',')[1];
                prezime = sve.Split(',')[2];
                datum = sve.Split(',')[3];
                dan = int.Parse(datum.Split('.')[0]);
                mesec = int.Parse(datum.Split('.')[1]);
                godina = int.Parse(datum.Split('.')[2]);
                dat = new DateTime(godina, mesec, dan);
                golovi = int.Parse(sve.Split(',')[4]);
                asistencije = int.Parse(sve.Split(',')[5]);
                pol = sve.Split(',')[6];
                if (pol == "m")
                    polSportiste = Pol.muski;
                else
                    polSportiste = Pol.zenski;


                svi.Add(new Fudbaler(regBr, ime, prezime, dat, polSportiste, asistencije, golovi));
            }

            InitializeComponent();
        }

        private void ucitajK_Click(object sender, RoutedEventArgs e)
        {
            foreach (Sportista item in svi.VratiEnumeratorPremaSelekciji(x => x is Kosarkas))
            {
                lbKosarkasi.Items.Add(item.ToString());
            }
        }

        private void ucitajF_Click(object sender, RoutedEventArgs e)
        {
            foreach (Sportista item in svi.VratiEnumeratorPremaSelekciji(x => x is Fudbaler))
            {
                lbKosarkasi.Items.Add(item.ToString());
            }
        }

        private void prikaziFilter_Click(object sender, RoutedEventArgs e)
        {
            if (indeks.Text != "")
            {
                info.Content = svi[int.Parse(indeks.Text)].ToString();
            }
        }

        private void prikazi_Click(object sender, RoutedEventArgs e)
        {
            if (cb.SelectedItem.ToString() == "Kosarkasice i fudbalerke")
            {
                foreach (Sportista item in svi.VratiEnumeratorPremaSelekciji(delegate(Object s) { Sportista s1 = (Sportista)s; return s1.PolSportiste == Pol.zenski; }))
                {
                    lbFilter.Items.Add(item.ToString());
                }
            }
        }



    }
}
