﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Kolokvijum
{

    public enum Pol
    {
        muski, zenski
    }

    public class Sportista : IUporediv<Sportista>
    {

        private string registracioniBroj;
        private string ime;
        private string prezime;
        private DateTime datumRodjenja;
        private Pol pol;

        public string RegistracioniBroj
        {
            get { return registracioniBroj; }
        }

        public string Ime
        {
            get { return ime; }
        }

        public string Prezime
        {
            get { return prezime; }
        }

        public DateTime DatumRodjenja
        {
            get { return datumRodjenja; }
        }

        public Pol PolSportiste
        {
            get { return pol; }
        }

        public Sportista(string regBr, string ime, string prezime, DateTime datum, Pol p)
        {
            this.registracioniBroj = regBr;
            this.ime = ime;
            this.prezime = prezime;
            this.datumRodjenja = datum;
            this.pol = p;
        }

        public virtual int IndexKorisnosti
        {
            get { return 0; }
        }

        public bool Uporedi(Sportista item)
        {
            if (this.RegistracioniBroj == item.RegistracioniBroj)
                return true;
            return false;
        }

        public override string ToString()
        {
            return IndexKorisnosti + ", " + this.Ime + ", " + this.Prezime + ", " + this.DatumRodjenja;
        }
    }
}
