﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.IO;


namespace FilipTubic7812
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
       
        public StreamReader fudbaleri = new StreamReader(Properties.Settings.Default.fudbaleri);
        public StreamReader kosarkasi = new StreamReader(Properties.Settings.Default.kosarkasi);

        public Lista<Sportista> listaSportista;
        public MainWindow()
        {
            InitializeComponent();
            fudbaleri = new StreamReader(Properties.Settings.Default.fudbaleri);
            kosarkasi = new StreamReader(Properties.Settings.Default.kosarkasi);
            this.cmbFilter.Items.Add("Sortirana lista sportista prema indeksu korisnosti");
            this.cmbFilter.Items.Add("Kosarkasice i fudbalerke");
            this.cmbFilter.Items.Add("Fudbalerke mladje od 20 godina prema broju postignutih golova");

        }

        private void btnUcitajKosarkase_Click(object sender, RoutedEventArgs e)
        {
            kosarkasi.ReadLine();
            while (!kosarkasi.EndOfStream)
            {
                String kosarkas = kosarkasi.ReadLine();
                string []linija = kosarkasi.ReadLine().Split(',');
                string regBroj = linija[0];
                string ime = linija[1];
                string prezime = linija[2];
                string []datum = linija[3].Split('.');
                int dan = int.Parse(datum[0]);
                int mesec = int.Parse(datum[1]);
                int godina = int.Parse(datum[2]);
                DateTime datumTime = new DateTime(godina, mesec, dan);
                int poeni = int.Parse(linija[4]);
                int asistencije = int.Parse(linija[5]);
                int uhvaceneLopte = int.Parse(linija[6]);
                string polS = linija[7];
                Pol pol = (polS == "m") ? Pol.muski : Pol.zenski;
                Kosarkas kos = new Kosarkas(regBroj, ime, prezime, datumTime, pol, asistencije, poeni, uhvaceneLopte);
                lstKosarkasi.Items.Add(kos);
                if (listaSportista == null)
                    listaSportista = new Lista<Sportista>(kos);
                else
                    listaSportista.Add(kos);
            }
        }

        private void btnUcitajFudbalere_Click(object sender, RoutedEventArgs e)
        {
            fudbaleri.ReadLine();
            while (!fudbaleri.EndOfStream)
            {
                String fudbaler = fudbaleri.ReadLine();
                string[] linija = fudbaleri.ReadLine().Split(',');
                string regBroj = linija[0];
                string ime = linija[1];
                string prezime = linija[2];
                string[] datum = linija[3].Split('.');
                int dan = int.Parse(datum[0]);
                int mesec = int.Parse(datum[1]);
                int godina = int.Parse(datum[2]);
                DateTime datumTime = new DateTime(godina, mesec, dan);

                int golovi = int.Parse(linija[4]);
                int asistencije = int.Parse(linija[5]);
                string pols = linija[6];
                Pol pol = (pols == "m") ? Pol.muski : Pol.zenski;

                Fudbaler fud = new Fudbaler(regBroj, ime, prezime, datumTime, pol, asistencije, golovi);
                this.lstFudbaleri.Items.Add(fud);

                if (listaSportista == null)
                    listaSportista = new Lista<Sportista>(fud);
                else
                    listaSportista.Add(fud);

            }
        }

        private void btnPrikazi_Click(object sender, RoutedEventArgs e)
        {
            if (this.cmbFilter.SelectedIndex==1)
            {
                foreach (var i in listaSportista.prodjiKrozListu((x)=>(x.PolSportiste == Pol.zenski)))
                {
                    lstPrikazi.Items.Add(i);
                }
            }
            else if (this.cmbFilter.SelectedIndex == 0)
            {
                //listaSportista.VratiSortiranuListu((x,y)=>(x.IndexKorisnosti>y.IndexKorisnosti));
            }

        }

        private void btnDajSportistu_Click(object sender, RoutedEventArgs e)
        {
            int index = int.Parse(txtIndeks.Text);
            lblInformacije.Content = "";
            lblInformacije.Content = listaSportista[index].elem;
        }
    }
}
