﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections;

namespace WpfApplication1
{
    

    public class Lista<T>:IEnumerable where T: IUporediv<T>
    {
        public T glava{get; set;}
        public Lista<T> next{get;set;}
        public delegate bool Delegat(T x);
        public delegate bool Delegat2(T x, T y);
        public Lista(T glava)
        {
            this.glava = glava;
            next=null;
        }
        

        public void Add(T podatak)
        {
            if(this==null)
                this.glava=podatak;
            else if(this.glava.Uporedi(podatak))
                next.Add(podatak);
        }
        
        public T this[int n]
        {
            get{
            Lista<T> bzvz=this;
            for(int i=0;i<n;i++)
                if(bzvz.next != null)
                {
                    bzvz=bzvz.next;
                }
                else return default(T);
            return bzvz.glava; }
        }



        public IEnumerator GetEnumerator()
        {
            Lista<T> bzvz=this;
            while (bzvz != null)
            {
                yield return bzvz.glava;
                bzvz = bzvz.next;
            }
        }


        public IEnumerable VratiEnumeratorPremaSelekciji(Delegat funkcija)
        {
            Lista<T> bzvz = this;
            while (bzvz != null)
            {
                if(funkcija(bzvz.glava))
                    yield return bzvz.glava;
                bzvz = bzvz.next;
            }
        }

        

        public Lista<T> vratiSortiranuListu(Delegat2 funkcija)
        {
            Lista<T> nova;
            Lista<T> prethodni;
            T min=default(T);
            foreach (T podatak in this)
            {
                if (min.Uporedi(default(T)))
                    min = podatak;
                
                else if (funkcija(podatak, min))
                    min = podatak;
            }
            nova=new Lista<T>(min);
            return nova;
        }

        public override string ToString()
        {
            string sviPodaci="";
            foreach (T podatak in this)
                sviPodaci += podatak.ToString()+"\n";
            return sviPodaci;
        }
    }
}
