﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;



namespace DrugiKol
{
   public delegate bool DelegatZaProveru<T>(T element);
   public delegate bool UslovSortiranja<T,U>(T e1,U e2);

    public class Lista<T> where T : IUporediv<T>
    {
        
        T glava;
        Lista<T> lista = null;
        int pozicija = 0;

        public Lista()
        {
        }

        public Lista(T element)
        {
            glava = element;
        }
        public void Add(T element)
        {
            Lista<T> lista = this.lista;
            int i = 0;
            while (lista != null)
            {
                if (lista.glava.Uporedi(element))
                    return;
                lista = lista.lista;
                i++;
            }
            lista = new Lista<T>(element);
            lista.pozicija = i;
        }
        public T this[int index]
        {
            get
            {
                Lista<T> lista = this.lista;
                while (lista != null && lista.pozicija != index)
                {
                    lista = lista.lista;
                }
                return lista.glava;
            }

        }

        public IEnumerable<T> Prolaz()
        {
            Lista<T> lista = this.lista;
            while (lista != null)
            {
                yield return glava;
                lista = lista.lista;
            }
        }
        public IEnumerable<T> VratiEnumeratorPremaSelekciji(DelegatZaProveru<T> del)
        {
            Lista<T> lista = this.lista;
            while (lista != null)
            {
                if(del(lista.glava))
                    yield return lista.glava;
                lista = lista.lista;
            }

        }
      /* public List<T> VratiSortiranuListu(UslovSortiranja<T, T> del)
        {
            
        }*/

        public Lista<T> VratiListuPremaSelekciji(DelegatZaProveru<T> del)
        {
            Lista<T> novaLista = new Lista<T>();
            
            foreach (T item in Prolaz())
            {
                if (del(item))
                {
                    novaLista.Add(item);
                }

            }
            return novaLista;
        }

        public override string ToString()
        {
            string s = "";
            foreach (T item in Prolaz())
            {
                s += item.ToString();
            }
            return s;
        }
    }

}

