﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace SportApp
{
    public class Fudbaler<T>:Sportista<T>
    {
        private int brojAsistencija;
        private int brojGolova;

        public Fudbaler(string registracioniBroj, string ime, string prezime, DateTime datumRodjenja, Pol pol, int brojAsistencija, int brojGolova)
            : base(registracioniBroj, ime, prezime, datumRodjenja, pol)
        {
            this.brojAsistencija = brojAsistencija;
            this.brojGolova = brojGolova;
        }
        

        public int BrojAsistencija
        {
            get
            {
                return brojAsistencija;
            }
        }

        public int BrojGolova
        {
            get
            {
                return brojGolova;
            }
        }

        public override int IndexKorisnosti
        {
            get
            {
                return BrojGolova * 30 + BrojAsistencija * 30;
            }
            set
            {
                base.IndexKorisnosti = value;
            }
        }

        public override string ToString()
        {
            return base.ToString() + " golovi = " +BrojGolova+ " asistencije = " +BrojAsistencija;
        }
    }
}
